﻿import mx.xpath.*; 


class SlideHolder extends MovieClip implements ISlideHolder {
	
	//set during attachMovie:
	private var owner:MovieClip; //controller
	
	private var styles:TextField.StyleSheet;
		
	private var slideData:SlideData;//model
	
	private var currentSlide:MovieClip;//a slide type (implementing ISlide)
	
	function SlideHolder(){
	}
	function refToSlideData(ref:SlideData){
		slideData=ref;
	}
	
	

	//redirect to current screen
	function nextStep(){
		if(currentSlide.getStep()<currentSlide.getTotalSteps()){
			currentSlide.nextStep();
		}else{
			owner.goNextSlide();
		}
	}
	function prevStep(){
		if(currentSlide.getStep()>0){
			currentSlide.prevStep();
		}else{
			owner.goPrevSlide();
		}
	}


	//===============
	/// required by the interface
	function getCSS():TextField.StyleSheet{
		return styles;
	}
	//was getNodeValue
	public function selectSingleNodeValue(data:XMLNode, path:String):String{
		return XPathAPI.selectSingleNode(data, path).firstChild.nodeValue;
	}
	//was getNode
	public function selectSingleNode(data:XMLNode, path:String):XMLNode{
		return XPathAPI.selectSingleNode(data, path);
	}
	//was getNodes
	public function selectNodeList(data:XMLNode, path:String):Array{
		return XPathAPI.selectNodeList(data, path);
	}
	//======================



	function goSlide(n:Number, startAtBeginning:Boolean){
		
		var thisSlideData=slideData.getSlideData(n);
		
		var type=thisSlideData.attributes.type;
		
		var dataToPass={owner:this,
						slideData:thisSlideData,
						startAtBeginning:startAtBeginning};
		
	
		currentSlide=this.createEmptyMovieClip("currentSlide",0);
		//make mcl
		var mcl:MovieClipLoader=new MovieClipLoader();
		//and listener
		var listener=new Object();
		//when full loaded, set vars and initialize
		listener.onLoadInit=function(target:MovieClip){
			target.init(dataToPass.owner, 
						dataToPass.slideData, 
						dataToPass.startAtBeginning);
		}
		mcl.addListener(listener);
		mcl.loadClip(type, currentSlide);
		
		
	}

	
	
}